"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const Qwik = require("@builder.io/qwik");
const tableCore = require("@tanstack/table-core");
function _interopNamespaceDefault(e) {
  const n = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
  if (e) {
    for (const k in e) {
      if (k !== "default") {
        const d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: () => e[k]
        });
      }
    }
  }
  n.default = e;
  return Object.freeze(n);
}
const Qwik__namespace = /* @__PURE__ */ _interopNamespaceDefault(Qwik);
const isFunction = (comp) => typeof comp === "function";
const isQwikComponent = (comp) => isFunction(comp) && comp.name === "QwikComponent";
function flexRender(Comp, props) {
  return !Comp ? null : isQwikComponent(Comp) ? /* @__PURE__ */ jsxRuntime.jsx(Comp, { ...props }) : isFunction(Comp) ? Comp(props) : Comp;
}
function useTable(options) {
  const resolvedOptions = {
    state: {},
    onStateChange: () => {
    },
    renderFallbackValue: null,
    ...options
  };
  const table = Qwik__namespace.useStore({
    instance: Qwik__namespace.noSerialize(tableCore._createTable(resolvedOptions))
  });
  const state = Qwik__namespace.useSignal(table.instance.initialState);
  table.instance.setOptions((prev) => ({
    ...prev,
    ...options,
    state: {
      ...state.value,
      ...options.state
    },
    // Similarly, we'll maintain both our internal state and any user-provided
    // state.
    onStateChange: (updater) => {
      var _a;
      state.value = updater instanceof Function ? updater(state.value) : updater;
      (_a = options.onStateChange) == null ? void 0 : _a.call(options, updater);
    }
  }));
  return table.instance;
}
exports.flexRender = flexRender;
exports.useTable = useTable;
Object.keys(tableCore).forEach((k) => {
  if (k !== "default" && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: () => tableCore[k]
  });
});
//# sourceMappingURL=index.cjs.map
