import { jsx } from "@builder.io/qwik/jsx-runtime";
import * as Qwik from "@builder.io/qwik";
import { _createTable } from "@tanstack/table-core";
export * from "@tanstack/table-core";
const isFunction = (comp) => typeof comp === "function";
const isQwikComponent = (comp) => isFunction(comp) && comp.name === "QwikComponent";
function flexRender(Comp, props) {
  return !Comp ? null : isQwikComponent(Comp) ? /* @__PURE__ */ jsx(Comp, { ...props }) : isFunction(Comp) ? Comp(props) : Comp;
}
function useTable(options) {
  const resolvedOptions = {
    state: {},
    onStateChange: () => {
    },
    renderFallbackValue: null,
    ...options
  };
  const table = Qwik.useStore({
    instance: Qwik.noSerialize(_createTable(resolvedOptions))
  });
  const state = Qwik.useSignal(table.instance.initialState);
  table.instance.setOptions((prev) => ({
    ...prev,
    ...options,
    state: {
      ...state.value,
      ...options.state
    },
    // Similarly, we'll maintain both our internal state and any user-provided
    // state.
    onStateChange: (updater) => {
      var _a;
      state.value = updater instanceof Function ? updater(state.value) : updater;
      (_a = options.onStateChange) == null ? void 0 : _a.call(options, updater);
    }
  }));
  return table.instance;
}
export {
  flexRender,
  useTable
};
//# sourceMappingURL=index.js.map
